// JavaScript source code
//mySwitchindex.js
var Service, Characteristic;
var net = require('net');
var client = new net.Socket();

var onbuf = new Buffer([0xaa, 0x08, 0, 0, 0, 0x14, 0, 0, 0, 0x66], 'hex');//cmd: turn on
var offbuf = new Buffer([0xaa, 0x08, 0, 0, 0, 0x14, 0, 0, 0, 0x44], 'hex');//cmd: turn off
var inibuf = new Buffer([0xaa, 0x08, 0, 0, 0, 0x14, 0, 0, 0, 0x55], 'hex');//cmd: reset

client.setEncoding('binary');
client.connect(777, '192.168.0.112', function () {
    console.log('Connecte Server OK!');//connect ser2net
});

module.exports = function (homebridge) {
    Service = homebridge.hap.Service;
    Characteristic = homebridge.hap.Characteristic;
    /* registerAccessory' three parameters is 
                            plugin-name(must begin with homebridge-* add must be defined in package.json), 
                        accessory-name(must be defined in config.js),
                        constructor-name(must be a function)*/
    homebridge.registerAccessory("homebridge-sevyswitch", "MyDormSwitch", mySwitch);
};

function mySwitch(log, config) {
    this.log = log;
    this.name = config['name'];//get parameter from config.json
    this.informationService = new Service.AccessoryInformation();

    this.switchService = new Service.Switch(this.name);// Service.Switch means this is a plugin of Switch
    this.switchService.getCharacteristic(Characteristic.On)
                .on('get', this.getSwitchOnCharacteristic.bind(this))
                .on('set', this.setSwitchOnCharacteristic.bind(this));
}

mySwitch.prototype.getServices = function () {
    return [this.switchService];
}

mySwitch.prototype.getSwitchOnCharacteristic = function (callback) {
    console.log("**************Get on Function**************");
    callback(null);
}

mySwitch.prototype.setSwitchOnCharacteristic = function (on, callback) {
    console.log("**************Set on Function:" + on + "**************");

    if (on)
        client.write(onbuf);
    else
        client.write(offbuf);

    setTimeout(function () {
        client.write(inibuf);
    }, 500);//500ms Rest init statue

    callback(null);
}

